> ## Documentation Index
> Fetch the complete documentation index at: https://docs.cortex.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Update user label assignments

> Assign user label values to user emails in bulk.

API key must have the `Edit user labels` permission.



## OpenAPI

````yaml /openapi/cortex_swagger.json post /api/v1/eng-intel/labels/users
openapi: 3.0.1
info:
  description: >-
    The Cortex REST API provides programmatic access to the data in the catalog,
    Scorecards, and more.
  title: Cortex API
  version: v1
servers:
  - url: https://api.getcortexapp.com
    description: Cortex Cloud API host
security:
  - bearerAuth: []
tags:
  - name: API Keys
  - name: Audit Logs
  - name: Catalog Entities
  - name: Catalogs
  - name: Custom Data
  - name: Custom Data [Advanced]
  - name: Custom Events
  - name: Custom Metrics
  - name: Dependencies
  - name: Deploys
  - name: Discovery Audit
  - name: Docs
  - name: 'Eng Intel: 1-Registry'
  - name: 'Eng Intel: 2-Metrics'
  - name: 'Eng Intel: 3-Trace'
  - name: 'Eng Intel: User Labels'
  - name: Entity Relationship Types
  - name: Entity Relationships
  - name: Entity Types
  - name: GitOps Logs
  - name: Groups
  - name: IP Allowlist
  - name: Initiatives
  - name: My Workspace
  - name: Notification Logs
  - name: On-call
  - name: Packages
  - name: Plugins
  - name: Queries
  - name: SCIM
  - name: Scaffolder
  - name: Scorecards
  - name: Secrets
  - name: Team Roles
  - name: Teams
  - name: Teams Hierarchies
  - name: Teams [Advanced]
  - name: Teams [Departments] (legacy)
  - name: Users
  - name: Verifications
  - name: Workflows
  - name: '[Integrations] AWS'
  - name: '[Integrations] Anthropic'
  - name: '[Integrations] Apiiro'
  - name: '[Integrations] ArgoCD'
  - name: '[Integrations] Azure Active Directory'
  - name: '[Integrations] Azure Devops'
  - name: '[Integrations] Azure Resources'
  - name: '[Integrations] BambooHR'
  - name: '[Integrations] Bitbucket'
  - name: '[Integrations] Bugsnag'
  - name: '[Integrations] Buildkite'
  - name: '[Integrations] Checkmarx SAST'
  - name: '[Integrations] CircleCI'
  - name: '[Integrations] ClickUp'
  - name: '[Integrations] Codecov'
  - name: '[Integrations] Coralogix'
  - name: '[Integrations] Datadog'
  - name: '[Integrations] Dynatrace'
  - name: '[Integrations] Firehydrant'
  - name: '[Integrations] GitHub'
  - name: '[Integrations] GitLab'
  - name: '[Integrations] Harness'
  - name: '[Integrations] Incident.io'
  - name: '[Integrations] Instana'
  - name: '[Integrations] Jenkins'
  - name: '[Integrations] Jira'
  - name: '[Integrations] Kubernetes'
  - name: '[Integrations] LaunchDarkly'
  - name: '[Integrations] Lightstep'
  - name: '[Integrations] Mend SAST'
  - name: '[Integrations] Mend SCA'
  - name: '[Integrations] New Relic'
  - name: '[Integrations] Okta'
  - name: '[Integrations] Opsgenie'
  - name: '[Integrations] PagerDuty'
  - name: '[Integrations] Prometheus'
  - name: '[Integrations] Rollbar'
  - name: '[Integrations] Rootly'
  - name: '[Integrations] Semgrep'
  - name: '[Integrations] Sentry'
  - name: '[Integrations] ServiceNow'
  - name: '[Integrations] SignalFx'
  - name: '[Integrations] Snyk'
  - name: '[Integrations] SonarQube'
  - name: '[Integrations] SumoLogic'
  - name: '[Integrations] Veracode'
  - name: '[Integrations] VictorOps'
  - name: '[Integrations] Wiz'
  - name: '[Integrations] Workday'
  - name: '[Integrations] xMatters'
  - name: dev-login-controller
  - name: public-scim-schema-controller
paths:
  /api/v1/eng-intel/labels/users:
    post:
      tags:
        - Eng Intel User Labels
      summary: Update user label assignments
      description: |-
        Assign user label values to user emails in bulk.

        API key must have the `Edit user labels` permission.
      operationId: updateUserLabelAssignments
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BulkUserLabelAssignmentRequest'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BulkUserLabelAssignmentResponse'
          description: Successfully updated user label assignments
        '429':
          $ref: '#/components/responses/TooManyRequests'
components:
  schemas:
    BulkUserLabelAssignmentRequest:
      required:
        - userLabelAssignments
      type: object
      properties:
        userLabelAssignments:
          type: object
          additionalProperties:
            type: array
            description: >-
              Map of user email to the list of user label values that should be
              assigned to the user
            example: |2-

                          {
                              "user@email.com": [
                                  {"id": "ul2da8159dbeefb974", "name": "Coding Language", "value": "Java"},
                                  {"id": "ul2da8159234bsdfas", "name": "Engineering Level", "value": "Senior"}
                              ],
                              "another_user@email.com": [
                                  {"id": "ul2da8159dbeefb974", "name": "Coding Language", "value": "Typescript"},
                              ]
                          }
                      
            items:
              $ref: '#/components/schemas/UserLabelValue'
          description: >-
            Map of user email to the list of user label values that should be
            assigned to the user
          example: |2-

                        {
                            "user@email.com": [
                                {"id": "ul2da8159dbeefb974", "name": "Coding Language", "value": "Java"},
                                {"id": "ul2da8159234bsdfas", "name": "Engineering Level", "value": "Senior"}
                            ],
                            "another_user@email.com": [
                                {"id": "ul2da8159dbeefb974", "name": "Coding Language", "value": "Typescript"},
                            ]
                        }
                    
    BulkUserLabelAssignmentResponse:
      required:
        - userLabelAssignments
      type: object
      properties:
        userLabelAssignments:
          type: object
          additionalProperties:
            type: array
            description: Map of user email to the list of assigned user label values
            items:
              $ref: '#/components/schemas/UserLabelValue'
          description: Map of user email to the list of assigned user label values
    UserLabelValue:
      required:
        - id
        - name
        - value
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        value:
          type: string
      description: Map of user email to the list of assigned user label values
    TooManyRequestsProblemDetail:
      required:
        - type
        - title
        - status
      type: object
      properties:
        detail:
          type: string
        instance:
          type: string
          format: uri-reference
        retryAfter:
          minimum: 0
          type: integer
          description: The number of seconds until the rate limiting resets.
          format: int32
        status:
          maximum: 599
          minimum: 100
          type: integer
          format: int32
          enum:
            - 429
        title:
          type: string
        type:
          type: string
          format: uri-reference
  responses:
    TooManyRequests:
      content:
        application/problem+json:
          schema:
            $ref: '#/components/schemas/TooManyRequestsProblemDetail'
      description: >-
        The client has exceeded the rate limit by performing too many requests
        in a short period. Retry the request after a delay.
      headers:
        Retry-After:
          description: The number of seconds until the rate limiting resets.
          schema:
            minimum: 0
            type: integer
            format: int32
  securitySchemes:
    bearerAuth:
      bearerFormat: JWT
      description: >-
        All requests to the Cortex API need to provide an `Authorization: Bearer
        <token>` header, where `<token>` is an API key created in the Settings
        page of your workspace.
      scheme: bearer
      type: http

````

## Related topics

- [Eng Intelligence: User Labels](/api/rest/eng-intel-user-labels.md)
- [List user role assignments](/api/rest/users/list-user-role-assignments.md)
- [Users](/api/rest/users.md)
